# -*- coding: utf-8 -*-

"""
bandwidth

This file was automatically generated by APIMATIC v2.0 ( https://apimatic.io ).
"""

from bandwidth.api_helper import APIHelper
import bandwidth.exceptions.api_exception


class PathClientException(bandwidth.exceptions.api_exception.APIException):
    def __init__(self, reason, response):
        """Constructor for the PathClientException class

        Args:
            reason (string): The reason (or error message) for the Exception
                to be raised.
            response (HttpResponse): The HttpResponse of the API call.

        """
        super(PathClientException, self).__init__(reason, response)
        dictionary = APIHelper.json_deserialize(self.response.text)
        if isinstance(dictionary, dict):
            self.unbox(dictionary)

    def unbox(self, dictionary):
        """Populates the properties of this object by extracting them from a dictionary.

        Args:
            dictionary (dictionary): A dictionary representation of the object as
            obtained from the deserialization of the server's response. The keys
            MUST match property names in the API description.

        """
        self.timestamp = dictionary.get('timestamp')
        self.status = dictionary.get('status')
        self.error = dictionary.get('error')
        self.message = dictionary.get('message')
        self.path = dictionary.get('path')
